*
* Programa...: EXEMPLO.PRG
* Finalidade.: Testar funcionalidades do NetIO
* Autor......: Alexandre Simes
* Data.......: 23/11/2011
* --------------------------------------------------------------
#include "inkey.ch"
#include "setcurs.ch"
#include "error.ch"
#include "achoice.ch"
#include "fileio.ch"
#include "common.ch"
#include "dbinfo.ch"
#include "hbver.ch"
#include "hbdyn.ch"
#include "wvtwin.ch"
#include "hbgtinfo.ch"
#include "hbgtwvg.ch"
#include "wvgparts.ch"
#include "hbcompat.ch"
#include "windows.ch"

FUNCTION MAIN
   //altd()
   IF !AbreDBF("CADASTRO")      
      QUIT
   ENDIF
   CADASTRO->(DbGoTop()) 
   CADASTRO->(OrdSetFocus(1))
   DbEdit()
   CADASTRO->(DbGoTop()) 
   CADASTRO->(OrdSetFocus(2))
   DbEdit()
RETURN Nil

INIT FUNCTION AppSetup()
  LOCAL  hWrite:=Hash(), hRead:=HB_ReadIni( "CONFIG.INI" )
  LOCAL  nVezes
  PUBLIC cServidorDB, cIpAddServer:=Obter_Ip_Maquina("servidor"), cPortaServer:="2816"

  REQUEST HB_LANG_PT
  REQUEST HB_CODEPAGE_PT850
  HB_LANGSELECT("PT")
  HB_CDPSELECT( "PT850" )

  REQUEST HB_GT_GUI_DEFAULT
  REQUEST HB_GT_WVG
  REQUEST HB_GT_WVT
  REQUEST HB_GT_WGU
  REQUEST DBFCDX
  RddSetDefault('DBFCDX')

  
  SETMODE(25,80)
  SET TYPEAHEAD TO 0
  SET INTENSITY ON
  SET SCOREBOARD OFF
  SET DELETED ON
  SET SAFETY OFF
  SET DATE ANSI
  SET ESCAPE ON
  SET CENTURY ON
  SET DELIMITERS TO
  SET EXCLUSIVE OFF
  SET WRAP ON
  SET EPOCH TO 1920
  SET OPTIMIZE ON
  SET DBFLOCKSCHEME TO DB_DBFLOCK_DEFAULT 
  SET MESSAGE TO 24 CENTER

  IF !File("CONFIG.INI")
     hWrite["MAIN" ]           := Hash()
     hWrite["MAIN" ]["Desc" ]  := "Sistema Exemplo"
     hWrite["MAIN" ]["Ver"  ]  := "Versao 1.0a"
     hWrite["CONFIGURACAO" ]             := Hash()
     hWrite["CONFIGURACAO" ]["Porta"]    := cPortaServer
     hWrite["CONFIGURACAO" ]["IPAddress"]:= cIpAddServer
     HB_WriteIni( "CONFIG.INI", hWrite,"--- Inicio ---", "--- Fim ---" )
  ELSE
     cPortaServer:=hRead["CONFIGURACAO"]["Porta"]
     cIpAddServer:=hRead["CONFIGURACAO"]["IPAddress"]
  ENDIF 

  //cIpAddrServer:="asaprev.dyndns.org"

  IF Empty(cIpAddServer)
     cIpAddServer:=Verifica_Ip()
  ENDIF
  
  cServidorDB:='net://'+cIpAddServer+':'+cPortaServer+':db'+HB_OSpathseparator()  
  
  nVezes:=0 
  
  DO WHILE !NetIO_Connect(cIpAddServer,Val(cPortaServer),1500,"senha")
     IF nVezes > 30
        MsgInfo("No foi possvel conectar ao servidor: "+cServidorDB+HB_OsNewLine()+;
             "Encerrando o sistema!" )
        DbCLoseAll()
        ExitProcess()
     ENDIF
     nVezes++
     IF nVezes >= 2  .AND. nVezes <= 15
        cIpAddServer:=Obter_Ip_Maquina("servidor")
     ELSEIF nVezes > 15
        cIpAddServer:=Verifica_Ip()
     ENDIF
  ENDDO
   
  cServidorDB:='net://'+cIpAddServer+':'+cPortaServer+':db'+HB_OSpathseparator()  
  
  IF nVezes > 1
     hWrite["MAIN" ]           := Hash()
     hWrite["MAIN" ]["Desc" ]  := "Sistema Exemplo"
     hWrite["MAIN" ]["Ver"  ]  := "Versao 1.0a"
     hWrite["CONFIGURACAO" ]             := Hash()
     hWrite["CONFIGURACAO" ]["Porta"]    := cPortaServer
     hWrite["CONFIGURACAO" ]["IPAddress"]:= cIpAddServer
     HB_WriteIni( "CONFIG.INI", hWrite,"--- Inicio ---", "--- Fim ---" )
  ENDIF

  IniciaJanela() 

RETURN Nil 

FUNCTION IniciaJanela(nLi,nCi,nLf,nCf)
LOCAL oCrt
PUBLIC hWnd,;
       cTituloJanela,;
       oDlgHabla,;
       oTimer,;
       cPrinter:= WIN_PrinterGetDefault()

DEFAULT nLi TO -1,;
        nCi TO -2,;
        nLf TO MaxRow(),;
        nCf TO MaxCol()  
  
  oCrt := WvgCrt():New( , , { nLi,nCi }, { nLf,nCf}, , .T. )
  
  oCrt:lModal := .F.
  oCrt:icon := 'power2.ico'
  oCrt:create()
  oCrt:resizable :=.F.
//---------------------------------------------------------------------------------------------------------
    WVT_SetFont("Lucida Console")
    cTituloJanela:=HB_OEMTOANSI("Sistema Exemplo")
    WVT_SetTitle(cTituloJanela)
    WVT_SetAltF4Close(.F. )
    HB_gtInfo( HB_GTI_SPEC, HB_GTS_WNDSTATE, HB_GTS_WS_MAXIMIZED )
    hWnd:=HWG_FindWindow( ,cTituloJanela)
//----------------------------------------------------------------------------------------------------------
RETURN Nil

FUNCTION Obter_Ip_Maquina(cMaquina)
LOCAL aHosts:={}
HB_InetInit()
aHosts := HB_InetGetHosts( cMaquina )
IF aHosts == NIL
   aHosts:=HB_InetGetAlias( cMaquina )
ENDIF
IF Empty(aHosts)
   aHosts:=HB_InetGetAlias( cMaquina )
ENDIF
HB_InetCleanup()
RETURN IF(Len(aHosts)>0,aHosts[1],"")

FUNCTION Verifica_Ip
LOCAL aHosts:={}, cEstacao:=NetName(.F.)
HB_InetInit()
aHosts := HB_InetGetHosts( cEstacao )
IF aHosts == NIL
   aHosts:=HB_InetGetAlias( cEstacao )
ENDIF
IF Empty(aHosts)
   aHosts:=HB_InetGetAlias( cEstacao )
ENDIF
HB_InetCleanup()
RETURN IF(Len(aHosts)>0,aHosts[1],"")

FUNCTION AbreDBF(cDataBase,lShared)
LOCAL nArea, cServer:=cServidorDB, lOk:=.T.

DEFAULT lShared TO .T.

IF Alias() = Upper(cDataBase)
   DbSelectArea(cDataBase)
   RETURN .T.
ENDIF

FOR nArea:=0 To 150
   IF !Empty((nArea)->(Alias()))
      If RTrim((nArea)->(Alias())) = Upper(cDataBase)
         DbSelectArea(cDataBase)
         RETURN .T.
      ENDIF
   ENDIF
NEXT

DO CASE
CASE UPPER(cDataBase) = 'CADASTRO'
   TRY
      IF !Netio_FuncExec("EXISTE","CADASTRO.CDX")
         NetUse(cServer,cDataBase,.T.) 
         INDEX ON CODIGO TAG CAD01
         INDEX ON NOME   TAG CAD02
         CADASTRO->(DbCloseArea()) 
      ENDIF
      lOk:=NetUse(cServer,cDataBase,lShared)
      SET INDEX TO (cServer+"CADASTRO.CDX")
   CATCH oErro
      MsgInfo("Erro na abertura da tabela","Aviso do Sistema")
   END
ENDCASE
RETURN lOk

FUNCTION NetUse(cServer,cDatabase,lOpenMode,nSeconds,cRDD)
LOCAL lForever, cDirTab:="", lOk:=.F.

DEFAULT lOpenMode TO .F.,;
        nSeconds  TO 0,;
        cRDD      TO "DBFCDX",;
        cServer   TO ""

lForever := (nSeconds = 0)
DO WHILE (lForever .Or. nSeconds > 0)
   IF lOpenMode
      DbUseArea(.T.,cRDD,cServer+cDataBase,cDataBase,.T.) //,"DBFCDX")
   ELSE
      DbUseArea(.T.,cRDD,cServer+cDataBase,cDataBase,.F.) //,"DBFCDX")
   ENDIF
   IF ! NetErr()                    // Use succeeds
      lOk:=.T. 
      EXIT
   ENDIF
   Inkey(1)         // Wait 1 second
   nSeconds--
ENDDO
RETURN lOk

